import { HttpResponseModel, ODataClient } from "@odata2ts/odata-client-api";
import { AjaxRequestConfig } from "./AjaxConfig";
export type ErrorMessageRetriever = (errorResponse: any) => string | undefined;
export interface ClientOptions {
}
export declare const getV2OrV4ErrorMessage: ErrorMessageRetriever;
export declare class JQueryODataClient implements ODataClient<AjaxRequestConfig> {
    private clientOptions?;
    private client;
    private config;
    private getErrorMessage;
    constructor(jquery: JQuery<any>, config?: AjaxRequestConfig, clientOptions?: ClientOptions | undefined);
    setErrorMessageRetriever(getErrorMsg: ErrorMessageRetriever): void;
    sendRequest<ResponseType>(config: JQuery.AjaxSettings, requestConfig?: AjaxRequestConfig): Promise<HttpResponseModel<ResponseType>>;
    post<ResponseModel>(url: string, data: any, requestConfig?: AjaxRequestConfig): Promise<HttpResponseModel<ResponseModel>>;
    get<ResponseModel>(url: string, requestConfig?: AjaxRequestConfig): Promise<HttpResponseModel<ResponseModel>>;
    put<ResponseModel>(url: string, data: any, requestConfig?: AjaxRequestConfig): Promise<HttpResponseModel<ResponseModel>>;
    patch<ResponseModel>(url: string, data: any, requestConfig?: AjaxRequestConfig): Promise<HttpResponseModel<ResponseModel>>;
    merge<ResponseModel>(url: string, data: any, requestConfig?: AjaxRequestConfig): Promise<HttpResponseModel<ResponseModel>>;
    delete(url: string, requestConfig?: AjaxRequestConfig): Promise<HttpResponseModel<void>>;
}
